
--------------------------COMPTADOR VECTORIAL------------------------------
library ieee;
	use ieee.std_logic_1164.all;
	use ieee.std_logic_unsigned.all;
	
entity Comptador_Vectorial is
	port (clk9kHz    : in std_logic;
			estat   : out integer range 0 to 5:=0;
			sector   : out integer range 0 to 30:=0);	
end entity;

architecture arch1 of Comptador_Vectorial is
	signal comptador1 : integer range 0 to 30:=0;
	signal comptador2 : integer range 0 to 5:=0;
begin
	process (clk9kHz) 
	begin
	-- cada flanc de pujada incrementem el valor del comptador
		if (rising_edge (clk9kHz)) then
			comptador1 <= comptador1 +1;
			if (comptador1 = 30) then
				 comptador1 <= 0;
				comptador2 <= comptador2 + 1; 
			end if;
			if (comptador2 = 5) then
				comptador2 <= 0;
			end if;
		end if;
		estat <= comptador1;
		sector <= comptador2;
	end process;
end architecture;