-----------------------SENYALS DE SORTIDA PWM------------------------------
	
library ieee;
	use ieee.std_logic_1164.all;
	use ieee.std_logic_unsigned.all;
	
entity PWM is
	port (etapa : in integer range 0 to 9:=0;
			Latx3Bits    : in integer range 0 to 11:=0;
			Sortida : out bit;
			NotSortida : out bit);	
end entity;

architecture arch1 of PWM is

begin
	process (etapa,Latx3Bits) 
	begin
			-- GENERACIÓ DE PWM PER A L'ETAPA 0
			if (etapa = 0 ) then
				if (Latx3Bits = 5 ) then
				Sortida <='1'; NotSortida <='0';
				else Sortida <='1'; NotSortida <='1';
				end if;
			end if;	
			
			-- GENERACIÓ DE PWM PER A L'ETAPA 1,L'ETAPA 8
			if (etapa = 1 or etapa = 8) then
				if (Latx3Bits = 4 or Latx3Bits = 5 or Latx3Bits = 6) then
				Sortida <='1'; NotSortida <='0';
				else Sortida <='1'; NotSortida <='1';
				end if;
			end if;
			
			-- GENERACIÓ DE PWM PER A L'ETAPA 2 i L'ETAPA 7
			if (etapa = 2 or etapa = 7) then
				if (Latx3Bits = 0 or Latx3Bits = 1 or Latx3Bits = 2 or
				Latx3Bits = 8 or Latx3Bits = 9 or 
				Latx3Bits = 10 or Latx3Bits = 11) then
				Sortida <='0'; NotSortida <='1';
				else Sortida <='1'; NotSortida <='0';
				end if;
			end if;
			
			-- GENERACIÓ DE PWM PER A L'ETAPA 3 i L'ETAPA 6
			if (etapa = 3 or etapa = 6) then
				if (Latx3Bits = 0 or Latx3Bits = 1 or Latx3Bits = 2 or
				Latx3Bits = 9 or Latx3Bits = 10 or Latx3Bits = 11) then
				Sortida <='0'; NotSortida <='1';
				else Sortida <='1'; NotSortida <='0';
				end if;
			end if;
			
			-- GENERACIÓ DE PWM PER A L'ETAPA 2 i L'ETAPA 7
			if (etapa = 4 or etapa = 5) then
				if (Latx3Bits = 0 or Latx3Bits = 1 or
				Latx3Bits = 10 or Latx3Bits = 11) then
				Sortida <='0'; NotSortida <='1';
				else Sortida <='1'; NotSortida <='0';
				end if;
			end if;
					
	end process;
end architecture;