--------------------------SORTIDES PWM VECTORIAL---------------------------
	
library ieee;
	use ieee.std_logic_1164.all;
	use ieee.std_logic_unsigned.all;
	
entity PWM_VECTORIAL is
	port (etapa : in integer range 0 to 5:=0;
			entrada_Latx5Bits    : in integer range 0 to 30:=0;
			branca_A,NotBranca_A : out bit;
			branca_B,NotBranca_B : out bit;
			branca_C,NotBranca_C : out bit);	
end entity;

architecture arch1 of PWM_VECTORIAL is
	signal bit_A,bit_B,bit_C : integer range 0 to 1:=0;

begin
	process (etapa,entrada_Latx5Bits) 
	begin

-- GENERACIÓ DE PWM PER A L'ETAPA 0
if (etapa = 0 ) then
	if (entrada_Latx5Bits < 2 or entrada_Latx5Bits > 27) then
		bit_A <= 0;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 2 and entrada_Latx5Bits < 7) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 7 and entrada_Latx5Bits < 12) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 0;
		elsif (entrada_Latx5Bits >= 12 and entrada_Latx5Bits < 17) then
			bit_A <= 1;	bit_B <= 1; bit_C <= 1;
		elsif(entrada_Latx5Bits >= 17 and entrada_Latx5Bits < 22) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 22 and entrada_Latx5Bits < 27) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 0;
	end if;
end if;

-- GENERACIÓ DE PWM PER A L'ETAPA 1
if (etapa = 1 ) then
	if (entrada_Latx5Bits < 2 or entrada_Latx5Bits > 27) then
		bit_A <= 0;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 2 and entrada_Latx5Bits < 7) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 7 and entrada_Latx5Bits < 12) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 12 and entrada_Latx5Bits < 17) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 17 and entrada_Latx5Bits < 22) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 22 and entrada_Latx5Bits < 27) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 0;
	end if;
end if;

-- GENERACIÓ DE PWM PER A L'ETAPA 2
if (etapa = 2 ) then
	if (entrada_Latx5Bits < 2 or entrada_Latx5Bits > 27) then
		bit_A <= 0;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 2 and entrada_Latx5Bits < 7 ) then
			bit_A <= 0; bit_B <= 1; bit_C <= 0;
		elsif(entrada_Latx5Bits >= 7 and entrada_Latx5Bits < 12 ) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 12 and entrada_Latx5Bits < 17) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 17 and entrada_Latx5Bits < 22) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 22 and entrada_Latx5Bits < 27) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 0;
	end if;
end if;

-- GENERACIÓ DE PWM PER A L'ETAPA 3
if (etapa = 3 ) then
	if (entrada_Latx5Bits < 2 or entrada_Latx5Bits > 27) then
		bit_A <= 0;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 2 and entrada_Latx5Bits < 7 ) then
			bit_A <= 0;	bit_B <= 0;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 7 and entrada_Latx5Bits < 12) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 12 and entrada_Latx5Bits < 17) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 17 and entrada_Latx5Bits < 22) then
			bit_A <= 0;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 22 and entrada_Latx5Bits < 27) then
			bit_A <= 0;	bit_B <= 0;	bit_C <= 1;
	end if;
end if;

-- GENERACIÓ DE PWM PER A L'ETAPA 4
if (etapa = 4 ) then
	if (entrada_Latx5Bits < 2 or entrada_Latx5Bits > 27) then
		bit_A <= 0;	bit_B <= 0; bit_C <= 0;
		elsif(entrada_Latx5Bits >= 2 and entrada_Latx5Bits < 7) then
			bit_A <= 0;	bit_B <= 0; bit_C <= 1;
		elsif(entrada_Latx5Bits >= 7 and entrada_Latx5Bits < 12) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 12 and entrada_Latx5Bits < 17) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 17 and entrada_Latx5Bits < 22) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 22 and entrada_Latx5Bits < 27) then
			bit_A <= 0;	bit_B <= 0;	bit_C <= 1;
	end if;
end if;

-- GENERACIÓ DE PWM PER A L'ETAPA 5
if (etapa = 5 ) then
	if (entrada_Latx5Bits < 2 or entrada_Latx5Bits > 27) then
		bit_A <= 0;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 2 and entrada_Latx5Bits < 7) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 0;
		elsif(entrada_Latx5Bits >= 7 and entrada_Latx5Bits < 12) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 12 and entrada_Latx5Bits < 17) then
			bit_A <= 1;	bit_B <= 1;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 17 and entrada_Latx5Bits < 22) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 1;
		elsif(entrada_Latx5Bits >= 22 and entrada_Latx5Bits < 27) then
			bit_A <= 1;	bit_B <= 0;	bit_C <= 0;
	end if;
end if;

-- Definim els valors de sortida de les diferents branques
if (bit_A = 0) then branca_A <= '0';NotBranca_A <= '1'; 
	else branca_A <='1';NotBranca_A <= '0'; 
end if;

if (bit_B = 0) then branca_B <= '0';NotBranca_B <= '1';
	else branca_B <='1';NotBranca_B <= '0';
end if;

if (bit_C = 0) then branca_C <= '0';NotBranca_C <= '1';
	else branca_C <='1';NotBranca_C <= '0';
end if;
	
end process;
end architecture;